'use strict';
var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator.throw(value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : new P(function (resolve) {
                resolve(result.value);
            }).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
require('source-map-support').install();
var assert = require('power-assert');
var _1 = require('../src/');
describe('error schema test', function () {
    it('no id schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee() {
            var schema;
            return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                    case 0:
                        schema = { type: 'object' };
                        _context.prev = 1;
                        _context.next = 4;
                        return _1.default([schema]);
                    case 4:
                        assert.fail();
                        _context.next = 10;
                        break;
                    case 7:
                        _context.prev = 7;
                        _context.t0 = _context['catch'](1);
                        assert.equal('There is no id in the input schema(s)', assert._expr(assert._capt(assert._capt(assert._capt(_context, 'arguments/1/object/object').t0, 'arguments/1/object').message, 'arguments/1'), {
                            content: 'assert.equal(\'There is no id in the input schema(s)\', _context.t0.message)',
                            filepath: 'test/error_case_test.js',
                            line: 54
                        }));
                    case 10:
                    case 'end':
                        return _context.stop();
                    }
                }
            }, _callee, this, [[
                    1,
                    7
                ]]);
        }));
    });
    it('unkown type schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee2() {
            var schema;
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                    case 0:
                        schema = {
                            id: '/test/unkown_type',
                            type: 'hoge'
                        };
                        _context2.prev = 1;
                        _context2.next = 4;
                        return _1.default([schema], 'I');
                    case 4:
                        assert.fail();
                        _context2.next = 10;
                        break;
                    case 7:
                        _context2.prev = 7;
                        _context2.t0 = _context2['catch'](1);
                        assert.equal('unknown type: hoge', assert._expr(assert._capt(assert._capt(assert._capt(_context2, 'arguments/1/object/object').t0, 'arguments/1/object').message, 'arguments/1'), {
                            content: 'assert.equal(\'unknown type: hoge\', _context2.t0.message)',
                            filepath: 'test/error_case_test.js',
                            line: 88
                        }));
                    case 10:
                    case 'end':
                        return _context2.stop();
                    }
                }
            }, _callee2, this, [[
                    1,
                    7
                ]]);
        }));
    });
    it('unkown type property', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee3() {
            var schema;
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
                while (1) {
                    switch (_context3.prev = _context3.next) {
                    case 0:
                        schema = {
                            id: '/test/unkown_property',
                            type: 'object',
                            properties: { name: { type: 'fuga' } }
                        };
                        _context3.prev = 1;
                        _context3.next = 4;
                        return _1.default([schema], 'I');
                    case 4:
                        assert.fail();
                        _context3.next = 10;
                        break;
                    case 7:
                        _context3.prev = 7;
                        _context3.t0 = _context3['catch'](1);
                        assert.equal('unknown type: fuga', assert._expr(assert._capt(assert._capt(assert._capt(_context3, 'arguments/1/object/object').t0, 'arguments/1/object').message, 'arguments/1'), {
                            content: 'assert.equal(\'unknown type: fuga\', _context3.t0.message)',
                            filepath: 'test/error_case_test.js',
                            line: 127
                        }));
                    case 10:
                    case 'end':
                        return _context3.stop();
                    }
                }
            }, _callee3, this, [[
                    1,
                    7
                ]]);
        }));
    });
    it('target of $ref is not found', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee4() {
            var schema;
            return regeneratorRuntime.wrap(function _callee4$(_context4) {
                while (1) {
                    switch (_context4.prev = _context4.next) {
                    case 0:
                        schema = {
                            id: '/test/target_not_found',
                            type: 'object',
                            properties: { ref: { $ref: '/notFound/id#' } }
                        };
                        _context4.prev = 1;
                        _context4.next = 4;
                        return _1.default([schema], 'I');
                    case 4:
                        assert.fail();
                        _context4.next = 10;
                        break;
                    case 7:
                        _context4.prev = 7;
                        _context4.t0 = _context4['catch'](1);
                        assert.equal('$ref target is not found: /notFound/id#', assert._expr(assert._capt(assert._capt(assert._capt(_context4, 'arguments/1/object/object').t0, 'arguments/1/object').message, 'arguments/1'), {
                            content: 'assert.equal(\'$ref target is not found: /notFound/id#\', _context4.t0.message)',
                            filepath: 'test/error_case_test.js',
                            line: 166
                        }));
                    case 10:
                    case 'end':
                        return _context4.stop();
                    }
                }
            }, _callee4, this, [[
                    1,
                    7
                ]]);
        }));
    });
    it('target of $ref is invalid path', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee5() {
            var schema;
            return regeneratorRuntime.wrap(function _callee5$(_context5) {
                while (1) {
                    switch (_context5.prev = _context5.next) {
                    case 0:
                        schema = {
                            id: '/test/target_not_found',
                            type: 'object',
                            properties: { ref: { $ref: '#hogefuga' } }
                        };
                        _context5.prev = 1;
                        _context5.next = 4;
                        return _1.default([schema], 'I');
                    case 4:
                        assert.fail();
                        _context5.next = 10;
                        break;
                    case 7:
                        _context5.prev = 7;
                        _context5.t0 = _context5['catch'](1);
                        assert.equal('$ref target is not found: /test/target_not_found#hogefuga', assert._expr(assert._capt(assert._capt(assert._capt(_context5, 'arguments/1/object/object').t0, 'arguments/1/object').message, 'arguments/1'), {
                            content: 'assert.equal(\'$ref target is not found: /test/target_not_found#hogefuga\', _context5.t0.message)',
                            filepath: 'test/error_case_test.js',
                            line: 205
                        }));
                    case 10:
                    case 'end':
                        return _context5.stop();
                    }
                }
            }, _callee5, this, [[
                    1,
                    7
                ]]);
        }));
    });
});
//# sourceMappingURL=error_case_test.js.map
