'use strict';
var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator.throw(value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : new P(function (resolve) {
                resolve(result.value);
            }).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
require('source-map-support').install();
var fs = require('fs');
var assert = require('power-assert');
var _1 = require('../src/');
describe('file schema test', function () {
    it('news schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee() {
            var schema, actual, expected;
            return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                    case 0:
                        schema = fs.readFileSync('./schema/news.json', { encoding: 'utf-8' });
                        _context.next = 3;
                        return _1.default([schema]);
                    case 3:
                        actual = _context.sent;
                        expected = fs.readFileSync('./test/expected_file/news.d.ts', { encoding: 'utf-8' });
                        assert.equal(assert._expr(assert._capt(actual, 'arguments/0'), {
                            content: 'assert.equal(actual, expected, actual)',
                            filepath: 'test/file_schema_test.js',
                            line: 47
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(actual, expected, actual)',
                            filepath: 'test/file_schema_test.js',
                            line: 47
                        }), actual);
                    case 6:
                    case 'end':
                        return _context.stop();
                    }
                }
            }, _callee, this);
        }));
    });
    it('JSON Schemas schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee2() {
            var schema, actual, expected;
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                    case 0:
                        schema = fs.readFileSync('./schema/schema', { encoding: 'utf-8' });
                        _context2.next = 3;
                        return _1.default([schema]);
                    case 3:
                        actual = _context2.sent;
                        expected = fs.readFileSync('./test/expected_file/schema.d.ts', { encoding: 'utf-8' });
                        assert.equal(assert._expr(assert._capt(actual, 'arguments/0'), {
                            content: 'assert.equal(actual, expected, actual)',
                            filepath: 'test/file_schema_test.js',
                            line: 72
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(actual, expected, actual)',
                            filepath: 'test/file_schema_test.js',
                            line: 72
                        }), actual);
                    case 6:
                    case 'end':
                        return _context2.stop();
                    }
                }
            }, _callee2, this);
        }));
    });
    it('related two schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee3() {
            var actual, expected;
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
                while (1) {
                    switch (_context3.prev = _context3.next) {
                    case 0:
                        _context3.next = 2;
                        return _1.default([
                            fs.readFileSync('./schema/apibase.json', { encoding: 'utf-8' }),
                            fs.readFileSync('./schema/apimeta.json', { encoding: 'utf-8' })
                        ]);
                    case 2:
                        actual = _context3.sent;
                        expected = fs.readFileSync('./test/expected_file/apimeta.d.ts', { encoding: 'utf-8' });
                        assert.equal(assert._expr(assert._capt(actual, 'arguments/0'), {
                            content: 'assert.equal(actual, expected, actual)',
                            filepath: 'test/file_schema_test.js',
                            line: 96
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(actual, expected, actual)',
                            filepath: 'test/file_schema_test.js',
                            line: 96
                        }), actual);
                    case 5:
                    case 'end':
                        return _context3.stop();
                    }
                }
            }, _callee3, this);
        }));
    });
    it('circular referenced schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee4() {
            var actual, expected;
            return regeneratorRuntime.wrap(function _callee4$(_context4) {
                while (1) {
                    switch (_context4.prev = _context4.next) {
                    case 0:
                        _context4.next = 2;
                        return _1.default([fs.readFileSync('./schema/circular.json', { encoding: 'utf-8' })]);
                    case 2:
                        actual = _context4.sent;
                        expected = fs.readFileSync('./test/expected_file/circular.d.ts', { encoding: 'utf-8' });
                        assert.equal(assert._expr(assert._capt(actual, 'arguments/0'), {
                            content: 'assert.equal(actual, expected, actual)',
                            filepath: 'test/file_schema_test.js',
                            line: 120
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(actual, expected, actual)',
                            filepath: 'test/file_schema_test.js',
                            line: 120
                        }), actual);
                    case 5:
                    case 'end':
                        return _context4.stop();
                    }
                }
            }, _callee4, this);
        }));
    });
    it('download related schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee5() {
            var actual, expected;
            return regeneratorRuntime.wrap(function _callee5$(_context5) {
                while (1) {
                    switch (_context5.prev = _context5.next) {
                    case 0:
                        _context5.next = 2;
                        return _1.default([fs.readFileSync('./schema/simple_example.json', { encoding: 'utf-8' })]);
                    case 2:
                        actual = _context5.sent;
                        expected = fs.readFileSync('./test/expected_file/simple_schema.d.ts', { encoding: 'utf-8' });
                        assert.equal(assert._expr(assert._capt(actual, 'arguments/0'), {
                            content: 'assert.equal(actual, expected, actual)',
                            filepath: 'test/file_schema_test.js',
                            line: 144
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(actual, expected, actual)',
                            filepath: 'test/file_schema_test.js',
                            line: 144
                        }), actual);
                    case 5:
                    case 'end':
                        return _context5.stop();
                    }
                }
            }, _callee5, this);
        }));
    });
    it('download related advanced schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee6() {
            var actual, expected;
            return regeneratorRuntime.wrap(function _callee6$(_context6) {
                while (1) {
                    switch (_context6.prev = _context6.next) {
                    case 0:
                        _context6.next = 2;
                        return _1.default([fs.readFileSync('./schema/advanced_example.json', { encoding: 'utf-8' })]);
                    case 2:
                        actual = _context6.sent;
                        expected = fs.readFileSync('./test/expected_file/advanced_schema.d.ts', { encoding: 'utf-8' });
                        assert.equal(assert._expr(assert._capt(actual, 'arguments/0'), {
                            content: 'assert.equal(actual, expected, actual)',
                            filepath: 'test/file_schema_test.js',
                            line: 168
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(actual, expected, actual)',
                            filepath: 'test/file_schema_test.js',
                            line: 168
                        }), actual);
                    case 5:
                    case 'end':
                        return _context6.stop();
                    }
                }
            }, _callee6, this);
        }));
    });
    it('swagger2.0 sample schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee7() {
            var actual, expected;
            return regeneratorRuntime.wrap(function _callee7$(_context7) {
                while (1) {
                    switch (_context7.prev = _context7.next) {
                    case 0:
                        _context7.next = 2;
                        return _1.default([fs.readFileSync('./schema/petstore-expanded.json', { encoding: 'utf-8' })]);
                    case 2:
                        actual = _context7.sent;
                        expected = fs.readFileSync('./test/expected_file/petstore-expanded.d.ts', { encoding: 'utf-8' });
                        assert.equal(assert._expr(assert._capt(actual, 'arguments/0'), {
                            content: 'assert.equal(actual, expected, actual)',
                            filepath: 'test/file_schema_test.js',
                            line: 192
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(actual, expected, actual)',
                            filepath: 'test/file_schema_test.js',
                            line: 192
                        }), actual);
                    case 5:
                    case 'end':
                        return _context7.stop();
                    }
                }
            }, _callee7, this);
        }));
    });
});
//# sourceMappingURL=file_schema_test.js.map
