'use strict';
var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator.throw(value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : new P(function (resolve) {
                resolve(result.value);
            }).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
require('source-map-support').install();
var assert = require('power-assert');
var _1 = require('../src/');
describe('simple schema test', function () {
    it('no property schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee() {
            var schema, result, expected;
            return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                    switch (_context.prev = _context.next) {
                    case 0:
                        schema = {
                            id: '/test/no_prop',
                            type: 'object'
                        };
                        _context.next = 3;
                        return _1.default([schema]);
                    case 3:
                        result = _context.sent;
                        expected = 'declare namespace Test {\n    export interface NoProp {\n    }\n}\n';
                        assert.equal(assert._expr(assert._capt(result, 'arguments/0'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 49
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 49
                        }), result);
                    case 6:
                    case 'end':
                        return _context.stop();
                    }
                }
            }, _callee, this);
        }));
    });
    it('one line schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee2() {
            var schema, result, expected;
            return regeneratorRuntime.wrap(function _callee2$(_context2) {
                while (1) {
                    switch (_context2.prev = _context2.next) {
                    case 0:
                        schema = {
                            id: '/test/one_line',
                            type: 'object',
                            properties: { name: { type: 'string' } }
                        };
                        _context2.next = 3;
                        return _1.default([schema], 'I');
                    case 3:
                        result = _context2.sent;
                        expected = 'declare namespace Test {\n    export interface IOneLine {\n        name?: string;\n    }\n}\n';
                        assert.equal(assert._expr(assert._capt(result, 'arguments/0'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 82
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 82
                        }), result);
                    case 6:
                    case 'end':
                        return _context2.stop();
                    }
                }
            }, _callee2, this);
        }));
    });
    it('no type schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee3() {
            var schema, result, expected;
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
                while (1) {
                    switch (_context3.prev = _context3.next) {
                    case 0:
                        schema = { id: '/test/no_type' };
                        _context3.next = 3;
                        return _1.default([schema], 'I');
                    case 3:
                        result = _context3.sent;
                        expected = 'declare namespace Test {\n    export type INoType = any;\n}\n';
                        assert.equal(assert._expr(assert._capt(result, 'arguments/0'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 109
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 109
                        }), result);
                    case 6:
                    case 'end':
                        return _context3.stop();
                    }
                }
            }, _callee3, this);
        }));
    });
    it('include array schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee4() {
            var schema, result, expected;
            return regeneratorRuntime.wrap(function _callee4$(_context4) {
                while (1) {
                    switch (_context4.prev = _context4.next) {
                    case 0:
                        schema = {
                            id: '/test/inc_array',
                            type: 'object',
                            properties: {
                                id: { type: 'integer' },
                                array: {
                                    type: 'array',
                                    items: {
                                        type: [
                                            'string',
                                            'integer'
                                        ]
                                    }
                                }
                            }
                        };
                        _context4.next = 3;
                        return _1.default([schema], 'T');
                    case 3:
                        result = _context4.sent;
                        expected = 'declare namespace Test {\n    export interface TIncArray {\n        id?: number;\n        array?: (string | number)[];\n    }\n}\n';
                        assert.equal(assert._expr(assert._capt(result, 'arguments/0'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 148
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 148
                        }), result);
                    case 6:
                    case 'end':
                        return _context4.stop();
                    }
                }
            }, _callee4, this);
        }));
    });
    it('all simple type schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee5() {
            var schema, result, expected;
            return regeneratorRuntime.wrap(function _callee5$(_context5) {
                while (1) {
                    switch (_context5.prev = _context5.next) {
                    case 0:
                        schema = {
                            id: '/test/all_simple_type',
                            type: 'object',
                            properties: {
                                array: {
                                    type: 'array',
                                    items: {
                                        anyOf: [
                                            { type: 'string' },
                                            {
                                                type: 'array',
                                                items: { type: 'string' }
                                            }
                                        ]
                                    }
                                },
                                boolean: { type: 'boolean' },
                                integer: { type: 'integer' },
                                null: { type: 'null' },
                                number: { type: 'number' },
                                object: { type: 'object' },
                                string: { type: 'string' }
                            },
                            required: [
                                'array',
                                'boolean',
                                'integer'
                            ]
                        };
                        _context5.next = 3;
                        return _1.default([schema], 'I');
                    case 3:
                        result = _context5.sent;
                        expected = 'declare namespace Test {\n    export interface IAllSimpleType {\n        array: (string | string[])[];\n        boolean: boolean;\n        integer: number;\n        null?: null;\n        number?: number;\n        object?: {\n        };\n        string?: string;\n    }\n}\n';
                        assert.equal(assert._expr(assert._capt(result, 'arguments/0'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 208
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 208
                        }), result);
                    case 6:
                    case 'end':
                        return _context5.stop();
                    }
                }
            }, _callee5, this);
        }));
    });
    it('inner object schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee6() {
            var schema, result, expected;
            return regeneratorRuntime.wrap(function _callee6$(_context6) {
                while (1) {
                    switch (_context6.prev = _context6.next) {
                    case 0:
                        schema = {
                            id: '/test/inner_object',
                            type: 'object',
                            properties: {
                                title: { type: 'string' },
                                options: {
                                    type: 'object',
                                    properties: {
                                        A: { type: 'integer' },
                                        B: { type: 'number' },
                                        C: { type: 'string' }
                                    }
                                }
                            }
                        };
                        _context6.next = 3;
                        return _1.default([schema], 'I');
                    case 3:
                        result = _context6.sent;
                        expected = 'declare namespace Test {\n    export interface IInnerObject {\n        title?: string;\n        options?: {\n            A?: number;\n            B?: number;\n            C?: string;\n        };\n    }\n}\n';
                        assert.equal(assert._expr(assert._capt(result, 'arguments/0'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 249
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 249
                        }), result);
                    case 6:
                    case 'end':
                        return _context6.stop();
                    }
                }
            }, _callee6, this);
        }));
    });
    it('object array schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee7() {
            var schema, result, expected;
            return regeneratorRuntime.wrap(function _callee7$(_context7) {
                while (1) {
                    switch (_context7.prev = _context7.next) {
                    case 0:
                        schema = {
                            id: '/test/object_array',
                            type: 'object',
                            properties: {
                                array: {
                                    type: 'array',
                                    items: {
                                        type: 'object',
                                        properties: {
                                            name: { type: 'string' },
                                            items: {
                                                type: 'array',
                                                items: { type: 'string' }
                                            }
                                        }
                                    }
                                }
                            }
                        };
                        _context7.next = 3;
                        return _1.default([schema], 'I');
                    case 3:
                        result = _context7.sent;
                        expected = 'declare namespace Test {\n    export interface IObjectArray {\n        array?: {\n            name?: string;\n            items?: string[];\n        }[];\n    }\n}\n';
                        assert.equal(assert._expr(assert._capt(result, 'arguments/0'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 294
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 294
                        }), result);
                    case 6:
                    case 'end':
                        return _context7.stop();
                    }
                }
            }, _callee7, this);
        }));
    });
    it('root array schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee8() {
            var schema, result, expected;
            return regeneratorRuntime.wrap(function _callee8$(_context8) {
                while (1) {
                    switch (_context8.prev = _context8.next) {
                    case 0:
                        schema = {
                            id: 'test/root/root_array',
                            type: 'array',
                            items: { type: 'string' }
                        };
                        _context8.next = 3;
                        return _1.default([schema], 'I');
                    case 3:
                        result = _context8.sent;
                        expected = 'declare namespace Test {\n    namespace Root {\n        export type IRootArray = string[];\n    }\n}\n';
                        assert.equal(assert._expr(assert._capt(result, 'arguments/0'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 325
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 325
                        }), result);
                    case 6:
                    case 'end':
                        return _context8.stop();
                    }
                }
            }, _callee8, this);
        }));
    });
    it('root any schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee9() {
            var schema, result, expected;
            return regeneratorRuntime.wrap(function _callee9$(_context9) {
                while (1) {
                    switch (_context9.prev = _context9.next) {
                    case 0:
                        schema = {
                            id: 'test/root/root_any',
                            description: 'This is any type schema',
                            additionalProperties: true
                        };
                        _context9.next = 3;
                        return _1.default([schema], 'I');
                    case 3:
                        result = _context9.sent;
                        expected = 'declare namespace Test {\n    namespace Root {\n        /**\n         * This is any type schema\n         */\n        export interface IRootAny {\n            [name: string]: any;\n        }\n    }\n}\n';
                        assert.equal(assert._expr(assert._capt(result, 'arguments/0'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 354
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 354
                        }), result);
                    case 6:
                    case 'end':
                        return _context9.stop();
                    }
                }
            }, _callee9, this);
        }));
    });
    it('include example schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee10() {
            var schema, result, expected;
            return regeneratorRuntime.wrap(function _callee10$(_context10) {
                while (1) {
                    switch (_context10.prev = _context10.next) {
                    case 0:
                        schema = {
                            id: 'test/example/root',
                            example: 'How get this schema.\nAlso, How get this data from hoge.',
                            properties: {
                                name: {
                                    type: [
                                        'string',
                                        'null'
                                    ],
                                    example: 'how get name property'
                                }
                            }
                        };
                        _context10.next = 3;
                        return _1.default([schema], 'I');
                    case 3:
                        result = _context10.sent;
                        expected = 'declare namespace Test {\n    namespace Example {\n        /**\n         * example:\n         *   How get this schema.\n         *   Also, How get this data from hoge.\n         */\n        export interface IRoot {\n            /**\n             * example: how get name property\n             */\n            name?: string;\n        }\n    }\n}\n';
                        assert.equal(assert._expr(assert._capt(result, 'arguments/0'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 388
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 388
                        }), result);
                    case 6:
                    case 'end':
                        return _context10.stop();
                    }
                }
            }, _callee10, this);
        }));
    });
    it('include $ref schema', function () {
        return __awaiter(undefined, void 0, void 0, regeneratorRuntime.mark(function _callee11() {
            var schema, result, expected;
            return regeneratorRuntime.wrap(function _callee11$(_context11) {
                while (1) {
                    switch (_context11.prev = _context11.next) {
                    case 0:
                        schema = {
                            id: 'test/ref/include_ref',
                            type: 'object',
                            definitions: { name: { type: 'string' } },
                            properties: { 'sub-name': { $ref: '#/definitions/name' } }
                        };
                        _context11.next = 3;
                        return _1.default([schema], 'I');
                    case 3:
                        result = _context11.sent;
                        expected = 'declare namespace Test {\n    namespace Ref {\n        export interface IIncludeRef {\n            "sub-name"?: IncludeRef.Definitions.IName;\n        }\n        namespace IncludeRef {\n            namespace Definitions {\n                export type IName = string;\n            }\n        }\n    }\n}\n';
                        assert.equal(assert._expr(assert._capt(result, 'arguments/0'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 426
                        }), assert._expr(assert._capt(expected, 'arguments/1'), {
                            content: 'assert.equal(result, expected, result)',
                            filepath: 'test/simple_schema_test.js',
                            line: 426
                        }), result);
                    case 6:
                    case 'end':
                        return _context11.stop();
                    }
                }
            }, _callee11, this);
        }));
    });
});
//# sourceMappingURL=simple_schema_test.js.map
